## fdb 5.11.105

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( fdb5 LANGUAGES C CXX )

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

CHECK_TYPE_SIZE(off_t SIZEOF_OFF_T)

if ("${SIZEOF_OFF_T}" LESS 8)
    MESSAGE(SEND_ERROR "Missing support for large files (off_t size < 64 bits)")
endif()

########################################################################################################################
### dependencies and options

### eckit

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_find_package( NAME eckit  VERSION 1.24.4 REQUIRED )

### GRIB support

ecbuild_find_package( NAME eccodes VERSION 2.10 QUIET )

ecbuild_add_option( FEATURE GRIB
                    DEFAULT ON
                    CONDITION eccodes_FOUND
                    DESCRIPTION "Support for GRIB via eccodes")

ecbuild_find_package( NAME metkit VERSION 1.5 REQUIRED )

### FDB backend in persistent memory, i.e. pmem (NVRAM)

ecbuild_add_option( FEATURE PMEMFDB # option present in fdb5_config.h
                    DEFAULT OFF
                    DESCRIPTION "Persistent memory (NVRAM) support for FDB"
                    REQUIRED_PACKAGES "NAME pmem" )

### FDB backend in CEPH object store (using Rados)

find_package( RADOS QUIET )
ecbuild_add_option( FEATURE RADOSFDB  # option defined in fdb5_config.h
                    CONDITION eckit_HAVE_RADOS AND RADOS_FOUND
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados support for FDB Store" )

### FDB backend in indexed filesystem with table-of-contents, i.e. TOC
### Supports Lustre parallel filesystem stripping control

ecbuild_add_option( FEATURE TOCFDB  # option defined in fdb5_config.h
                    DEFAULT ON
                    DESCRIPTION "Filesystem TOC support for FDB" )

### support for Lustre API control of file stripping

find_package( LUSTREAPI QUIET )

ecbuild_add_option( FEATURE LUSTRE  # option defined in fdb5_config.h
                    CONDITION LUSTREAPI_FOUND
                    DEFAULT ON
                    DESCRIPTION "Support for Lustre API control of file stripping " )

### experimental & sandbox features

ecbuild_add_option( FEATURE FDB_REMOTE
                    DEFAULT ON
                    DESCRIPTION "Support for FDB remote access" )

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features" )

ecbuild_add_option( FEATURE SANDBOX
                    DESCRIPTION "build the sandbox stuff"
                    DEFAULT OFF	 )

### build the tools

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

if(HAVE_BUILD_TOOLS)
    set(_default_fdb_tools ON)
else()
    set(_default_fdb_tools OFF)
endif()

ecbuild_add_option( FEATURE FDB_BUILD_TOOLS
                    DEFAULT ${_default_fdb_tools}
                    DESCRIPTION "Build the command line FDB tools" )

### find thread library ( preferably pthreads )

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package(Threads REQUIRED)

### checks

# check thread library is pthreads

if( NOT ${CMAKE_USE_PTHREADS_INIT} )
	message( FATAL_ERROR "Only pthreads supported - thread library found is [${CMAKE_THREAD_LIBS_INIT}]" )
endif()

########################################################################################################################
# contents

include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings

set( fdb5_INCLUDE_DIRS  ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )

include_directories( ${fdb5_INCLUDE_DIRS} )

set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS};${ECCODES_DEFINITIONS}" )

get_directory_property( fdb5_DEFINITIONS COMPILE_DEFINITIONS )

### source files

add_subdirectory( src )
add_subdirectory( tests )

### finalize


ecbuild_install_project( NAME fdb )

ecbuild_print_summary()

=== src/CMakeLists.txt ===
############################################################################################
# libraries

ecbuild_find_project_files()

add_subdirectory( fdb5 )

############################################################################################
# following directories are not packaged
# currently this is developer only, hence not distributed

if( EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/sandbox/CMakeLists.txt )
	add_subdirectory( sandbox  )
endif()

=== src/fdb5/CMakeLists.txt ===
ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/fdb5 )

configure_file( fdb5_config.h.in    fdb5_config.h   )
configure_file( fdb5_version.h.in   fdb5_version.h  )
configure_file( fdb5_version.c.in   ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.c   )

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/fdb5_config.h
               ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.h
         DESTINATION ${INSTALL_INCLUDE_DIR}/fdb5 )

# fdb5 library

list( APPEND fdb5_srcs
    ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.c
	LibFdb5.h
	LibFdb5.cc

    api/fdb_c.cc
    api/fdb_c.h
    api/DistFDB.cc
    api/DistFDB.h
    api/FDB.cc
    api/FDB.h
    api/FDBFactory.cc
    api/FDBFactory.h
    api/FDBStats.cc
    api/FDBStats.h
    api/LocalFDB.cc
    api/LocalFDB.h
    api/RandomFDB.cc
    api/SelectFDB.cc
    api/SelectFDB.h

    api/helpers/APIIterator.h
    api/helpers/ControlIterator.cc
    api/helpers/ControlIterator.h
    api/helpers/FDBToolRequest.cc
    api/helpers/FDBToolRequest.h
    api/helpers/DumpIterator.h
    api/helpers/ListIterator.cc
    api/helpers/ListIterator.h
    api/helpers/LockIterator.h
    api/helpers/MoveIterator.h
    api/helpers/StatusIterator.h
    api/helpers/WipeIterator.h
    api/helpers/PurgeIterator.h
    api/helpers/StatsIterator.cc
    api/helpers/StatsIterator.h

    api/local/QueryVisitor.h
    api/local/QueueStringLogTarget.h
    api/local/ListVisitor.h
    api/local/ControlVisitor.cc
    api/local/ControlVisitor.h
    api/local/DumpVisitor.h
    api/local/WipeVisitor.cc
    api/local/WipeVisitor.h
    api/local/MoveVisitor.cc
    api/local/MoveVisitor.h
    api/local/PurgeVisitor.cc
    api/local/PurgeVisitor.h
    api/local/StatsVisitor.cc
    api/local/StatsVisitor.h
    api/local/StatusVisitor.h

    config/Config.cc
    config/Config.h
    database/Archiver.cc
    database/Archiver.h
    database/ArchiveVisitor.cc
    database/ArchiveVisitor.h
    database/AxisRegistry.cc
    database/AxisRegistry.h
    database/BaseArchiveVisitor.cc
    database/BaseArchiveVisitor.h
    database/Catalogue.cc
    database/Catalogue.h
    database/DataStats.cc
    database/DataStats.h
    database/DbStats.cc
    database/DbStats.h
    database/Engine.cc
    database/Engine.h
    database/EntryVisitMechanism.cc
    database/EntryVisitMechanism.h
    database/Field.cc
    database/Field.h
    database/FieldDetails.cc
    database/FieldDetails.h
    database/FieldLocation.cc
    database/FieldLocation.h
    database/UriStore.cc
    database/UriStore.h
    database/Indexer.cc
    database/Indexer.h
    database/Index.cc
    database/Index.h
    database/IndexLocation.cc
    database/IndexLocation.h
    database/IndexStats.cc
    database/IndexStats.h
    database/Inspector.cc
    database/Inspector.h
    database/StatsReportVisitor.cc
    database/StatsReportVisitor.h
    database/Store.cc
    database/Store.h
    database/PurgeVisitor.cc
    database/PurgeVisitor.h
    database/WipeVisitor.cc
    database/WipeVisitor.h
    database/MoveVisitor.cc
    database/MoveVisitor.h
    database/IndexAxis.cc
    database/IndexAxis.h
    database/IndexFactory.cc
    database/IndexFactory.h
    database/Key.cc
    database/Key.h
    database/InspectionKey.cc
    database/InspectionKey.h
    # database/ReadVisitor.cc
    database/ReadVisitor.h
    database/Report.cc
    database/Report.h
    database/RetrieveVisitor.cc
    database/RetrieveVisitor.h
    database/MultiRetrieveVisitor.cc
    database/MultiRetrieveVisitor.h
    database/WriteVisitor.cc
    database/WriteVisitor.h
    database/Notifier.cc
    database/Notifier.h
    database/Manager.cc
    database/Manager.h
    message/MessageArchiver.cc
    message/MessageArchiver.h
    message/MessageDecoder.cc
    message/MessageDecoder.h
    message/MessageIndexer.cc
    message/MessageIndexer.h
    io/FDBFileHandle.cc
    io/FDBFileHandle.h
    io/LustreSettings.cc
    io/LustreSettings.h
    io/LustreFileHandle.h
    io/HandleGatherer.cc
    io/HandleGatherer.h
    rules/MatchAlways.cc
    rules/MatchAlways.h
    rules/MatchAny.cc
    rules/MatchAny.h
    rules/Matcher.cc
    rules/Matcher.h
    rules/MatchHidden.cc
    rules/MatchHidden.h
    rules/MatchOptional.cc
    rules/MatchOptional.h
    rules/MatchValue.cc
    rules/MatchValue.h
    rules/Predicate.cc
    rules/Predicate.h
    rules/Rule.cc
    rules/Rule.h
    rules/Schema.cc
    rules/Schema.h
    rules/SchemaParser.cc
    rules/SchemaParser.h
    tools/FDBTool.cc
    tools/FDBTool.h
    tools/FDBVisitTool.cc
    tools/FDBVisitTool.h
    types/Type.cc
    types/Type.h
    types/TypeAbbreviation.cc
    types/TypeAbbreviation.h
    types/TypeClimateDaily.cc
    types/TypeClimateDaily.h
    types/TypeClimateMonthly.cc
    types/TypeClimateMonthly.h
    types/TypeDate.cc
    types/TypeDate.h
    types/TypeDefault.cc
    types/TypeDefault.h
    types/TypeDouble.cc
    types/TypeDouble.cc
    types/TypeDouble.h
    types/TypeDouble.h
    types/TypeExpver.cc
    types/TypeExpver.h
    types/TypeGrid.cc
    types/TypeGrid.h
    types/TypeIgnore.cc
    types/TypeIgnore.h
    types/TypeInteger.cc
    types/TypeInteger.h
    types/TypeMonth.cc
    types/TypeMonth.h
    types/TypeParam.cc
    types/TypeParam.h
    types/TypesFactory.cc
    types/TypesFactory.h
    types/TypesRegistry.cc
    types/TypesRegistry.h
    types/TypeStep.cc
    types/TypeStep.h
    types/TypeTime.cc
    types/TypeTime.h
)

if(HAVE_FDB_REMOTE)
    list( APPEND fdb5_srcs 
        # api/ClientFDB.cc
        # api/ClientFDB.h
        api/RemoteFDB.cc
        api/RemoteFDB.h
        remote/RemoteStore.cc
        remote/RemoteStore.h
        remote/RemoteCatalogue.h
        remote/RemoteCatalogue.cc
        # remote/RemoteEngine.h
        # remote/RemoteEngine.cc
        remote/Connection.h
        remote/Connection.cc

        remote/client/Client.h
        remote/client/Client.cc
        remote/client/ClientConnection.h
        remote/client/ClientConnection.cc
        remote/client/ClientConnectionRouter.h
        remote/client/ClientConnectionRouter.cc
        remote/server/CatalogueHandler.h
        remote/server/CatalogueHandler.cc
        remote/server/StoreHandler.h
        remote/server/StoreHandler.cc
        remote/server/ServerConnection.h
        remote/server/ServerConnection.cc
        remote/RemoteConfiguration.h
        remote/RemoteConfiguration.cc
        remote/RemoteFieldLocation.h
        remote/RemoteFieldLocation.cc
        remote/Messages.h
        remote/Messages.cc
        remote/AvailablePortList.cc
        remote/AvailablePortList.h
        remote/FdbServer.h
        remote/FdbServer.cc
    )
endif()

if(fdb5_HAVE_LUSTRE)
  list( APPEND fdb5_srcs io/fdb5_lustreapi_file_create.c )
endif()

if ( HAVE_GRIB )
    list( APPEND fdb5_srcs
        io/SingleGribMungePartFileHandle.cc
        io/SingleGribMungePartFileHandle.h
    )
endif()

if( HAVE_TOCFDB )
    list( APPEND fdb5_srcs
        toc/AdoptVisitor.cc
        toc/AdoptVisitor.h
        toc/BTreeIndex.cc
        toc/BTreeIndex.h
        toc/Root.cc
        toc/Root.h
        toc/FieldRef.cc
        toc/FieldRef.h
        toc/FileSpaceHandler.cc
        toc/FileSpaceHandler.h
        toc/FileSpace.cc
        toc/FileSpace.h
        toc/ExpverFileSpaceHandler.cc
        toc/ExpverFileSpaceHandler.h
        toc/EnvVarFileSpaceHandler.cc
        toc/EnvVarFileSpaceHandler.h
        toc/RootManager.cc
        toc/RootManager.h
        toc/TocCommon.cc
        toc/TocCommon.h
        toc/TocCatalogue.cc
        toc/TocCatalogue.h
        toc/TocCatalogueReader.cc
        toc/TocCatalogueReader.h
        toc/TocCatalogueWriter.cc
        toc/TocCatalogueWriter.h
        toc/TocFieldLocation.cc
        toc/TocFieldLocation.h
        toc/TocHandler.cc
        toc/TocHandler.h
        toc/TocIndex.cc
        toc/TocIndex.h
        toc/TocIndexLocation.cc
        toc/TocIndexLocation.h
        toc/TocPurgeVisitor.cc
        toc/TocPurgeVisitor.h
        toc/TocSerialisationVersion.cc
        toc/TocSerialisationVersion.h
        toc/TocWipeVisitor.cc
        toc/TocWipeVisitor.h
        toc/TocMoveVisitor.cc
        toc/TocMoveVisitor.h
        toc/TocRecord.cc
        toc/TocRecord.h
        toc/TocStats.cc
        toc/TocStats.h
        toc/TocStore.cc
        toc/TocStore.h
        toc/TocEngine.cc
        toc/TocEngine.h
        )

    list( APPEND fdb5_tools
        fdb-wipe
        fdb-stats
        fdb-purge
        fdb-dump-toc
        fdb-dump-index
        fdb-move
        fdb-reconsolidate-toc )
endif()

if( HAVE_PMEMFDB )

    list( APPEND fdb5_srcs
        pmem/DataPool.cc
        pmem/DataPool.h
        pmem/DataPoolManager.cc
        pmem/DataPoolManager.h
        pmem/MemoryBufferStream.h
        pmem/MemoryBufferStream.cc
        pmem/PBaseNode.cc
        pmem/PBaseNode.h
        pmem/PBranchingNode.cc
        pmem/PBranchingNode.h
        pmem/PDataNode.cc
        pmem/PDataNode.h
        pmem/PDataRoot.cc
        pmem/PDataRoot.h
        pmem/PIndexRoot.cc
        pmem/PIndexRoot.h
        pmem/PMemDB.cc
        pmem/PMemDB.h
        pmem/PMemDBReader.cc
        pmem/PMemDBReader.h
        pmem/PMemDBWriter.cc
        pmem/PMemDBWriter.h
        pmem/PMemFieldLocation.cc
        pmem/PMemFieldLocation.h
        pmem/PMemIndex.cc
        pmem/PMemIndex.h
        pmem/PMemIndexLocation.cc
        pmem/PMemIndexLocation.h
        pmem/PRoot.cc
        pmem/PRoot.h
        pmem/Pool.cc
        pmem/Pool.h
        pmem/PoolEntry.cc
        pmem/PoolEntry.h
        pmem/PoolGroup.cc
        pmem/PoolGroup.h
        pmem/PoolManager.cc
        pmem/PoolManager.h
        pmem/PMemStats.cc
        pmem/PMemStats.h
        pmem/PMemEngine.cc
        pmem/PMemEngine.h
    )

else()
    set( PMEM_LIBRARIES "" )
    set( PMEM_INCLUDE_DIRS "" )
endif()

if( HAVE_RADOSFDB )
    list( APPEND fdb5_srcs
        rados/RadosFieldLocation.cc
        rados/RadosFieldLocation.h
        rados/RadosStore.cc
        rados/RadosStore.h
    )
endif()

ecbuild_add_library(

    TARGET  fdb5
    
    TYPE SHARED # Library needs to be shared for dynamic factory self registration

    SOURCES
        ${fdb5_srcs}

    INSTALL_HEADERS LISTED

    HEADER_DESTINATION
        ${INSTALL_INCLUDE_DIR}/fdb5

    PUBLIC_INCLUDES
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>

    PUBLIC_LIBS
        metkit
        eckit
        eckit_option

    PRIVATE_INCLUDES
        "${PMEM_INCLUDE_DIRS}"
        "${LUSTREAPI_INCLUDE_DIRS}"

    PRIVATE_LIBS
        ${grib_handling_pkg}
        ${PMEM_LIBRARIES}
        ${LUSTREAPI_LIBRARIES}
)

if(HAVE_FDB_BUILD_TOOLS)

  list( APPEND fdb5_scripts fdb fdb-which )

  foreach( _script ${fdb5_scripts} )
    configure_file(scripts/${_script}.in ${CMAKE_BINARY_DIR}/bin/${_script} @ONLY)
    install(PROGRAMS ${CMAKE_BINARY_DIR}/bin/${_script} DESTINATION ${INSTALL_BIN_DIR} )
  endforeach()
endif()

list( APPEND fdb5_tools
    fdb-write
    fdb-copy
    fdb-dump
    fdb-list
    fdb-read
    fdb-schema
    fdb-where
    fdb-info
    fdb-status
    fdb-lock
    fdb-unlock
)

if ( HAVE_GRIB )
    list( APPEND fdb5_tools
        fdb-hammer
        fdb-patch
    )
endif()

if ( HAVE_TOCFDB )
    list(APPEND fdb5_tools
        fdb-root
        fdb-overlay
        fdb-hide
    )
endif()

foreach( _tool ${fdb5_tools} )

  ecbuild_add_executable( TARGET    ${_tool}
                          CONDITION HAVE_FDB_BUILD_TOOLS
                          SOURCES   tools/${_tool}.cc
                          INCLUDES  ${ECCODES_INCLUDE_DIRS}  # Please don't remove me, I am needed
                          LIBS      fdb5 )

endforeach()

if (HAVE_FDB_BUILD_TOOLS)
    target_link_libraries( fdb-move eckit_distributed )
endif()

ecbuild_add_executable( TARGET    grib2fdb5
                        CONDITION HAVE_FDB_BUILD_TOOLS
                        SOURCES   compat/grib2fdb5.cc
                        INCLUDES  ${ECCODES_INCLUDE_DIRS} # Please don't remove me, I am needed

=== tests/fdb/CMakeLists.txt ===
configure_file( etc/mars/wind       ${PROJECT_BINARY_DIR}/etc/mars/wind       @ONLY )

configure_file( etc/fdb/config.yaml ${PROJECT_BINARY_DIR}/etc/fdb/config.yaml @ONLY )
configure_file( etc/fdb/schema      ${PROJECT_BINARY_DIR}/etc/fdb/schema      @ONLY )
#configure_file( etc/fdb/engines  ${CMAKE_BINARY_DIR}/etc/fdb/engines   @ONLY )

file( MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/fdb/root ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/roots file
file( MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/fdb/root2 ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/roots file

# for pmem based FDB
configure_file( etc/fdb/pools      ${PROJECT_BINARY_DIR}/etc/fdb/pools       @ONLY )
configure_file( etc/fdb/poolgroups ${PROJECT_BINARY_DIR}/etc/fdb/poolgroups  @ONLY )

file( MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/fdb/pool ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/pools file

###############################################################################
# fdb unit tests

list( APPEND _test_environment
    FDB_HOME=${PROJECT_BINARY_DIR} )

list( APPEND fdb_tests
    test_fdb5_service.cc )

foreach( _tst ${fdb_tests} )

  get_filename_component(_test_name ${_tst} NAME_WE)

  ecbuild_add_test(
      TARGET  fdb5_${_test_name}
      SOURCES  ${_tst}
      INCLUDES ${ECCODES_INCLUDE_DIRS}
      ENVIRONMENT "${_test_environment}"
      LIBS  fdb5 )

endforeach()

###############################################################################
# fdb tool tests

list( APPEND _test_data
  "rd.vod.grib"
)

ecbuild_get_test_multidata( TARGET fdb5_get_test_data NAMES ${_test_data} )

foreach( _tst ${_test_data} )

    # define tool location using cmake-generator-expressions
    # see https://cmake.org/cmake/help/v3.4/manual/cmake-generator-expressions.7.html

    ecbuild_add_test(
        TARGET  fdb5_archive_${_tst}
        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_GRIB
        COMMAND $<TARGET_FILE:fdb-write>
        TEST_DEPENDS fdb5_get_test_data
        ARGS    ${_tst}
        ENVIRONMENT "${_test_environment}" )

      ecbuild_add_test(
          TARGET  fdb5_extract_${_tst}
          CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_GRIB
          COMMAND $<TARGET_FILE:fdb-read>
          TEST_DEPENDS fdb5_archive_${_tst}
          ARGS   --extract ${_tst} ${_tst}.2
          ENVIRONMENT "${_test_environment}" )

endforeach()

#################################################################################
# pmem tests make use of the test environment, so are added at the end

add_subdirectory( pmem )
add_subdirectory( api )
add_subdirectory( tools )
add_subdirectory( type )

=== tests/regressions/CMakeLists.txt ===
if (HAVE_FDB_BUILD_TOOLS) # test scripts use the fdb tools

    if (HAVE_GRIB)
        add_subdirectory(FDB-238)
        add_subdirectory(FDB-239)
        add_subdirectory(FDB-240)
        add_subdirectory(FDB-243)
        add_subdirectory(FDB-245)
        add_subdirectory(FDB-251)
        add_subdirectory(FDB-258)
        add_subdirectory(FDB-260)
        add_subdirectory(FDB-264)
        add_subdirectory(FDB-266)
        add_subdirectory(FDB-267)
        add_subdirectory(FDB-268)
        add_subdirectory(FDB-271)
        add_subdirectory(FDB-275)
        add_subdirectory(FDB-276)
        add_subdirectory(FDB-282)
        add_subdirectory(FDB-291)
        add_subdirectory(FDB-292)
        add_subdirectory(FDB-307)
        add_subdirectory(FDB-310)
    endif()

    add_subdirectory(FDB-241)

endif()

=== tests/fdb/api/CMakeLists.txt ===
### test data files
list( APPEND fdb_api_test_data_files
x138-300.grib
x138-400.grib
y138-400.grib
)

list( APPEND _test_environment
    FDB_HOME=${PROJECT_BINARY_DIR} )

if(ECCODES_DEFINITION_PATH AND (EXISTS ${ECCODES_DEFINITION_PATH}))
    list( APPEND _test_environment 
        ECCODES_DEFINITION_PATH=${ECCODES_DEFINITION_PATH})
endif()

if(ECCODES_SAMPLES_PATH AND (EXISTS ${ECCODES_SAMPLES_PATH}))
    list( APPEND _test_environment 
    ECCODES_SAMPLES_PATH=${ECCODES_SAMPLES_PATH})
endif()
    
ecbuild_get_test_multidata( TARGET get_fdb_api_test_data
                            NAMES ${fdb_api_test_data_files}
                            NOCHECK )

list( APPEND api_tests
    config
    select
    dist
    fdb_c
)

foreach( _test ${api_tests} )

    ecbuild_add_test( TARGET test_fdb5_api_${_test}
                      SOURCES test_${_test}.cc
                      TEST_DEPENDS get_fdb_api_test_data
                      LIBS fdb5
                      ENVIRONMENT "${_test_environment}" )

endforeach()

=== tests/fdb/tools/CMakeLists.txt ===
list( APPEND fdb_tools_tests
    fdb_info )

foreach( _t ${fdb_tools_tests} )
    
    configure_file( ${_t}.sh.in ${_t}.sh @ONLY )

    ecbuild_add_test(
        TYPE SCRIPT
        CONDITION HAVE_FDB_BUILD_TOOLS
        COMMAND ${_t}.sh)

endforeach()

=== tests/regressions/FDB-291/CMakeLists.txt ===
ecbuild_configure_file( FDB-291.sh.in FDB-291.sh @ONLY )
ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  FDB-291.sh )

=== debian/changelog ===
fdb (5.11.105-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:14:26 +0000

fdb (5.11.105-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 03 Mar 2024 15:59:14 +0000

=== debian/control ===
Source: fdb
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (=13),
 architecture-is-64-bit,
 ecbuild (>= 3.3.0-3),
 libeckit-dev (>= 1.23.0-1~),
 libeccodes-dev,
 libopenjp2-7-dev,
 libmetkit-dev,
 libodc-dev,
 libmetkit-utils (>= 1.8.10~1~),
 libpmem-dev [amd64 arm64 ppc64el riscv64],
 librados-dev [!sparc64 !ppc64 !alpha !loong64],
 libeccodes-tools
Standards-Version: 4.6.2
Homepage: https://github.com/ecmwf/fdb
Vcs-Browser: https://salsa.debian.org:/science-team/fdb.git
Vcs-Git: https://salsa.debian.org:/science-team/fdb.git -b debian/latest

Package: libfdb5-0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library for the ECMWF Fields Database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.

Package: libfdb5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfdb5-0d (= ${binary:Version}), 
  ${misc:Depends}, libeckit-dev
Recommends: pkgconf
Description: Development files for the ECMWF Fields database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.
 .
 This package provides shared libraries and headers.

Package: fdb5
Multi-Arch: foreign
Architecture: any
Depends: libfdb5-0d ( = ${binary:Version}), 
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libfdb5-dev (= ${binary:Version})
Description: Utilities for the FDB Fields Database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

ARCH:=$(shell dpkg --print-architecture)
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
DESTDIR:=$(CURDIR)/debian/tmp
BUILDDIR:=debian/build

ARCH_PMEM:= amd64 arm64 ppc64el
DO_PMEM:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_PMEM)),ON,OFF)

ARCH_NORADOS:= kfreebsd-amd64  ia64 alpha loong64 ppc64 sparc64
DO_RADOS:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NORADOS)),OFF,ON)

# The magic debhelper  rule
%:
	dh $@ --buildsystem=ecbuild --builddirectory=$(BUILDDIR)


# Disable for now
BUILD_FLAGS:=  -DENABLE_RPATHS=OFF \
		-DENABLE_RELATIVE_RPATHS=OFF \
		-DENABLE_PMEMFDB=OFF \
		-DENABLE_RADOSFDB=OFF \
		-DENABLE_LUSTRE=OFF 

override_dh_auto_configure:
	mkdir -p  $(BUILDDIR)/data  
	( cd $(BUILDDIR)/data ; tar axpf $(CURDIR)/../fdb_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
	dh_auto_configure -- \
		      ${BUILD_FLAGS}


override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(DESTDIR)/$(LIBDIR)/cmake/fdb5/fdb5-targets.cmake

override_dh_auto_test:
	LD_LIBRARY_PATH=$(BUILDDIR)/lib dh_auto_test ||  echo "Ignoring test failures" 

override_dh_fixperms-arch:
	chrpath -d debian/fdb5/usr/bin/fdb-move
	dh_fixperms

## fdb 5.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -127,7 +127,6 @@
 
 ### finalize
 
-
 ecbuild_install_project( NAME fdb )
 
 ecbuild_print_summary()

=== src/fdb5/CMakeLists.txt ===
--- 
+++ 
@@ -32,6 +32,8 @@
     api/SelectFDB.h
 
     api/helpers/APIIterator.h
+    api/helpers/AxesIterator.cc
+    api/helpers/AxesIterator.h
     api/helpers/ControlIterator.cc
     api/helpers/ControlIterator.h
     api/helpers/FDBToolRequest.cc
@@ -50,6 +52,8 @@
     api/local/QueryVisitor.h
     api/local/QueueStringLogTarget.h
     api/local/ListVisitor.h
+    api/local/AxesVisitor.cc
+    api/local/AxesVisitor.h
     api/local/ControlVisitor.cc
     api/local/ControlVisitor.h
     api/local/DumpVisitor.h
@@ -75,6 +79,8 @@
     database/BaseArchiveVisitor.h
     database/Catalogue.cc
     database/Catalogue.h
+    database/DB.cc
+    database/DB.h
     database/DataStats.cc
     database/DataStats.h
     database/DbStats.cc
@@ -117,9 +123,7 @@
     database/IndexFactory.h
     database/Key.cc
     database/Key.h
-    database/InspectionKey.cc
-    database/InspectionKey.h
-    # database/ReadVisitor.cc
+    database/ReadVisitor.cc
     database/ReadVisitor.h
     database/Report.cc
     database/Report.h
@@ -210,37 +214,17 @@
 
 if(HAVE_FDB_REMOTE)
     list( APPEND fdb5_srcs 
-        # api/ClientFDB.cc
-        # api/ClientFDB.h
         api/RemoteFDB.cc
         api/RemoteFDB.h
-        remote/RemoteStore.cc
-        remote/RemoteStore.h
-        remote/RemoteCatalogue.h
-        remote/RemoteCatalogue.cc
-        # remote/RemoteEngine.h
-        # remote/RemoteEngine.cc
-        remote/Connection.h
-        remote/Connection.cc
-
-        remote/client/Client.h
-        remote/client/Client.cc
-        remote/client/ClientConnection.h
-        remote/client/ClientConnection.cc
-        remote/client/ClientConnectionRouter.h
-        remote/client/ClientConnectionRouter.cc
-        remote/server/CatalogueHandler.h
-        remote/server/CatalogueHandler.cc
-        remote/server/StoreHandler.h
-        remote/server/StoreHandler.cc
-        remote/server/ServerConnection.h
-        remote/server/ServerConnection.cc
+
         remote/RemoteConfiguration.h
         remote/RemoteConfiguration.cc
         remote/RemoteFieldLocation.h
         remote/RemoteFieldLocation.cc
         remote/Messages.h
         remote/Messages.cc
+        remote/Handler.h
+        remote/Handler.cc
         remote/AvailablePortList.cc
         remote/AvailablePortList.h
         remote/FdbServer.h
@@ -428,6 +412,7 @@
 endif()
 
 list( APPEND fdb5_tools
+    fdb-axes
     fdb-write
     fdb-copy
     fdb-dump
@@ -474,3 +459,22 @@
                         CONDITION HAVE_FDB_BUILD_TOOLS
                         SOURCES   compat/grib2fdb5.cc
                         INCLUDES  ${ECCODES_INCLUDE_DIRS} # Please don't remove me, I am needed
+                        LIBS      fdb5 )
+
+ecbuild_add_executable(
+        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_FDB_REMOTE AND eckit_HAVE_ECKIT_CMD
+        TARGET fdb-monitor
+        SOURCES remote/fdb-monitor.cc
+        LIBS eckit eckit_cmd )
+
+ecbuild_add_executable(
+        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_FDB_REMOTE
+        TARGET fdb-server
+        SOURCES
+            remote/fdb-server.cc
+        LIBS fdb5 )
+
+if ( HAVE_FDB_BUILD_TOOLS )
+    target_sources( fdb-lock PRIVATE tools/FDBLock.cc tools/FDBLock.h )
+    target_sources( fdb-unlock PRIVATE tools/FDBLock.cc tools/FDBLock.h )
+endif()

=== tests/fdb/CMakeLists.txt ===
--- 
+++ 
@@ -72,5 +72,6 @@
 
 add_subdirectory( pmem )
 add_subdirectory( api )
+add_subdirectory( database )
 add_subdirectory( tools )
 add_subdirectory( type )

=== tests/fdb/database/CMakeLists.txt ===

list( APPEND _test_environment
    FDB_HOME=${PROJECT_BINARY_DIR} )

ecbuild_add_test( TARGET test_fdb5_database_indexaxis
    SOURCES test_indexaxis.cc
    INCLUDES ${PMEM_INCLUDE_DIRS}
    LIBS fdb5
    ENVIRONMENT "${_test_environment}")

=== tests/fdb/tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 list( APPEND fdb_tools_tests
-    fdb_info )
+    fdb_info
+    fdb_axes )
 
 foreach( _t ${fdb_tools_tests} )

=== debian/changelog ===
fdb (5.12.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 15 Apr 2024 09:05:55 +0100

fdb (5.12.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 08 Apr 2024 11:13:00 +0100

fdb (5.11.113-1) unsrable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 05 Apr 2024 08:44:56 +0100

fdb (5.11.112-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 28 Mar 2024 06:57:40 +0000

fdb (5.11.111-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 16 Mar 2024 09:39:29 +0000

fdb (5.11.110-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Mar 2024 16:06:09 +0000

fdb (5.11.108-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Mar 2024 13:17:54 +0000

fdb (5.11.107-1) unstable; urgency=medium

  * New upstream release
  
 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Mar 2024 07:02:27 +0000

## fdb 5.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -70,6 +70,45 @@
                     DEFAULT ON
                     DESCRIPTION "Support for FDB remote access" )
 
+find_package(UUID QUIET)
+
+find_package(DAOS QUIET)
+
+set(_default_dummy_daos ON)
+if(DAOS_FOUND)
+    set(_default_dummy_daos OFF)
+endif()
+
+ecbuild_add_option( FEATURE DUMMY_DAOS
+                    DEFAULT ${_default_dummy_daos}
+                    CONDITION UUID_FOUND
+                    DESCRIPTION "Use dummy DAOS library emulating DAOS with a file system" )
+
+if(HAVE_DUMMY_DAOS)
+    set(DAOS_LIBRARIES dummy_daos)
+    set(DAOS_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/src/dummy_daos)
+    set(DAOS_FOUND TRUE)
+    set(DAOS_TESTS_LIBRARIES dummy_daos_tests)
+    set(DAOS_TESTS_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/src/dummy_daos)
+    set(DAOS_TESTS_FOUND TRUE)
+endif()
+
+ecbuild_add_option( FEATURE DAOSFDB
+                    CONDITION DAOS_FOUND AND UUID_FOUND 
+                    DEFAULT ON
+                    DESCRIPTION "DAOS support for FDB Store" )
+
+ecbuild_add_option( FEATURE DAOS_ADMIN
+                    DEFAULT ${_default_dummy_daos}
+                    CONDITION HAVE_DAOSFDB AND DAOS_TESTS_FOUND
+                    DESCRIPTION "Add features for DAOS pool management. Removes need to manually create a pool for DAOS unit tests" )
+
+# DAOS_TESTS is a daos admin library, usually not present
+if(NOT HAVE_DAOS_ADMIN)
+    set( DAOS_TESTS_LIBRARIES "" )
+    set( DAOS_TESTS_INCLUDE_DIRS "" )
+endif()
+
 ecbuild_add_option( FEATURE EXPERIMENTAL
                     DEFAULT OFF
                     DESCRIPTION "Experimental features" )

=== src/fdb5/CMakeLists.txt ===
--- 
+++ 
@@ -48,6 +48,7 @@
     api/helpers/PurgeIterator.h
     api/helpers/StatsIterator.cc
     api/helpers/StatsIterator.h
+    api/helpers/Callback.h
 
     api/local/QueryVisitor.h
     api/local/QueueStringLogTarget.h
@@ -81,6 +82,8 @@
     database/Catalogue.h
     database/DB.cc
     database/DB.h
+    database/DatabaseNotFoundException.cc
+    database/DatabaseNotFoundException.h
     database/DataStats.cc
     database/DataStats.h
     database/DbStats.cc
@@ -368,6 +371,60 @@
     )
 endif()
 
+if( HAVE_DAOSFDB )
+    list( APPEND fdb5_srcs
+        daos/DaosOID.cc
+        daos/DaosOID.h
+        daos/DaosName.cc
+        daos/DaosName.h
+        daos/DaosObject.cc
+        daos/DaosObject.h
+        daos/DaosContainer.cc
+        daos/DaosContainer.h
+        daos/DaosPool.cc
+        daos/DaosPool.h
+        daos/DaosSession.cc
+        daos/DaosSession.h
+        daos/DaosArrayHandle.cc
+        daos/DaosArrayHandle.h
+        daos/DaosKeyValueHandle.cc
+        daos/DaosKeyValueHandle.h
+        daos/DaosStore.h 
+        daos/DaosStore.cc 
+        daos/DaosFieldLocation.h 
+        daos/DaosFieldLocation.cc
+        daos/DaosException.h
+        daos/DaosException.cc
+        daos/DaosEngine.h
+        daos/DaosEngine.cc 
+        daos/DaosCatalogue.h 
+        daos/DaosCatalogue.cc 
+        daos/DaosCatalogueWriter.h 
+        daos/DaosCatalogueWriter.cc
+        daos/DaosCatalogueReader.h 
+        daos/DaosCatalogueReader.cc
+        daos/DaosIndex.h
+        daos/DaosIndex.cc
+        daos/DaosIndexLocation.h
+        daos/DaosIndexLocation.cc
+        daos/DaosCommon.h
+        daos/DaosCommon.cc
+        daos/DaosWipeVisitor.h 
+        daos/DaosWipeVisitor.cc
+        daos/DaosArrayPartHandle.h 
+        daos/DaosArrayPartHandle.cc
+        daos/DaosLazyFieldLocation.h 
+        daos/DaosLazyFieldLocation.cc
+        daos/UUID.h
+        daos/UUID.cc
+    )
+else()
+    set( DAOS_LIBRARIES "" )
+    set( DAOS_INCLUDE_DIRS "" )
+    set( UUID_LIBRARIES "" )
+    set( UUID_INCLUDE_DIRS "" )
+endif()
+
 ecbuild_add_library(
 
     TARGET  fdb5
@@ -390,15 +447,20 @@
         metkit
         eckit
         eckit_option
+        "${UUID_LIBRARIES}"
 
     PRIVATE_INCLUDES
         "${PMEM_INCLUDE_DIRS}"
         "${LUSTREAPI_INCLUDE_DIRS}"
+        "${DAOS_INCLUDE_DIRS}"
+        "${DAOS_TESTS_INCLUDE_DIRS}"
 
     PRIVATE_LIBS
         ${grib_handling_pkg}
         ${PMEM_LIBRARIES}
         ${LUSTREAPI_LIBRARIES}
+        "${DAOS_LIBRARIES}"
+        "${DAOS_TESTS_LIBRARIES}"
 )
 
 if(HAVE_FDB_BUILD_TOOLS)
@@ -407,74 +469,3 @@
 
   foreach( _script ${fdb5_scripts} )
     configure_file(scripts/${_script}.in ${CMAKE_BINARY_DIR}/bin/${_script} @ONLY)
-    install(PROGRAMS ${CMAKE_BINARY_DIR}/bin/${_script} DESTINATION ${INSTALL_BIN_DIR} )
-  endforeach()
-endif()
-
-list( APPEND fdb5_tools
-    fdb-axes
-    fdb-write
-    fdb-copy
-    fdb-dump
-    fdb-list
-    fdb-read
-    fdb-schema
-    fdb-where
-    fdb-info
-    fdb-status
-    fdb-lock
-    fdb-unlock
-)
-
-if ( HAVE_GRIB )
-    list( APPEND fdb5_tools
-        fdb-hammer
-        fdb-patch
-    )
-endif()
-
-if ( HAVE_TOCFDB )
-    list(APPEND fdb5_tools
-        fdb-root
-        fdb-overlay
-        fdb-hide
-    )
-endif()
-
-foreach( _tool ${fdb5_tools} )
-
-  ecbuild_add_executable( TARGET    ${_tool}
-                          CONDITION HAVE_FDB_BUILD_TOOLS
-                          SOURCES   tools/${_tool}.cc
-                          INCLUDES  ${ECCODES_INCLUDE_DIRS}  # Please don't remove me, I am needed
-                          LIBS      fdb5 )
-
-endforeach()
-
-if (HAVE_FDB_BUILD_TOOLS)
-    target_link_libraries( fdb-move eckit_distributed )
-endif()
-
-ecbuild_add_executable( TARGET    grib2fdb5
-                        CONDITION HAVE_FDB_BUILD_TOOLS
-                        SOURCES   compat/grib2fdb5.cc
-                        INCLUDES  ${ECCODES_INCLUDE_DIRS} # Please don't remove me, I am needed
-                        LIBS      fdb5 )
-
-ecbuild_add_executable(
-        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_FDB_REMOTE AND eckit_HAVE_ECKIT_CMD
-        TARGET fdb-monitor
-        SOURCES remote/fdb-monitor.cc
-        LIBS eckit eckit_cmd )
-
-ecbuild_add_executable(
-        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_FDB_REMOTE
-        TARGET fdb-server
-        SOURCES
-            remote/fdb-server.cc
-        LIBS fdb5 )
-
-if ( HAVE_FDB_BUILD_TOOLS )
-    target_sources( fdb-lock PRIVATE tools/FDBLock.cc tools/FDBLock.h )
-    target_sources( fdb-unlock PRIVATE tools/FDBLock.cc tools/FDBLock.h )
-endif()

=== tests/fdb/CMakeLists.txt ===
--- 
+++ 
@@ -75,3 +75,4 @@
 add_subdirectory( database )
 add_subdirectory( tools )
 add_subdirectory( type )
+add_subdirectory( daos )

=== tests/fdb/tools/CMakeLists.txt ===
--- 
+++ 
@@ -12,3 +12,5 @@
         COMMAND ${_t}.sh)
 
 endforeach()
+
+add_subdirectory( auxiliary )

=== tests/fdb/tools/auxiliary/CMakeLists.txt ===
if (HAVE_FDB_BUILD_TOOLS)
    ecbuild_configure_file( move_auxiliary.sh.in fdb_move_auxiliary.sh @ONLY )

    ecbuild_add_test(
        TYPE SCRIPT
        CONDITION HAVE_FDB_BUILD_TOOLS
        COMMAND fdb_move_auxiliary.sh)
endif()

=== debian/changelog ===
fdb (5.13.0-1) unstable; urgency=medium

  * New upstream release
  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 13 Aug 2024 06:07:56 +0100

## fdb 5.14.0~rc1

=== CMakeLists.txt ===
--- 
+++ 
@@ -166,6 +166,7 @@
 
 ### finalize
 
+
 ecbuild_install_project( NAME fdb )
 
 ecbuild_print_summary()

=== src/fdb5/CMakeLists.txt ===
--- 
+++ 
@@ -80,8 +80,6 @@
     database/BaseArchiveVisitor.h
     database/Catalogue.cc
     database/Catalogue.h
-    database/DB.cc
-    database/DB.h
     database/DatabaseNotFoundException.cc
     database/DatabaseNotFoundException.h
     database/DataStats.cc
@@ -126,7 +124,6 @@
     database/IndexFactory.h
     database/Key.cc
     database/Key.h
-    database/ReadVisitor.cc
     database/ReadVisitor.h
     database/Report.cc
     database/Report.h
@@ -153,6 +150,8 @@
     io/LustreFileHandle.h
     io/HandleGatherer.cc
     io/HandleGatherer.h
+    io/FieldHandle.cc
+    io/FieldHandle.h
     rules/MatchAlways.cc
     rules/MatchAlways.h
     rules/MatchAny.cc
@@ -220,18 +219,37 @@
         api/RemoteFDB.cc
         api/RemoteFDB.h
 
-        remote/RemoteConfiguration.h
-        remote/RemoteConfiguration.cc
+        remote/Connection.h
+        remote/Connection.cc
         remote/RemoteFieldLocation.h
         remote/RemoteFieldLocation.cc
         remote/Messages.h
         remote/Messages.cc
-        remote/Handler.h
-        remote/Handler.cc
-        remote/AvailablePortList.cc
-        remote/AvailablePortList.h
         remote/FdbServer.h
         remote/FdbServer.cc
+
+        remote/client/Client.h
+        remote/client/Client.cc
+        remote/client/ClientConnection.h
+        remote/client/ClientConnection.cc
+        remote/client/ClientConnectionRouter.h
+        remote/client/ClientConnectionRouter.cc
+        remote/client/RemoteStore.cc
+        remote/client/RemoteStore.h
+        remote/client/RemoteCatalogue.h
+        remote/client/RemoteCatalogue.cc
+
+        remote/server/AvailablePortList.cc
+        remote/server/AvailablePortList.h
+        remote/server/CatalogueHandler.h
+        remote/server/CatalogueHandler.cc
+        remote/server/StoreHandler.h
+        remote/server/StoreHandler.cc
+        remote/server/ServerConnection.h
+        remote/server/ServerConnection.cc
+
+        # remote/RemoteConfiguration.h
+        # remote/RemoteConfiguration.cc
     )
 endif()
 
@@ -445,27 +463,3 @@
 
     PUBLIC_LIBS
         metkit
-        eckit
-        eckit_option
-        "${UUID_LIBRARIES}"
-
-    PRIVATE_INCLUDES
-        "${PMEM_INCLUDE_DIRS}"
-        "${LUSTREAPI_INCLUDE_DIRS}"
-        "${DAOS_INCLUDE_DIRS}"
-        "${DAOS_TESTS_INCLUDE_DIRS}"
-
-    PRIVATE_LIBS
-        ${grib_handling_pkg}
-        ${PMEM_LIBRARIES}
-        ${LUSTREAPI_LIBRARIES}
-        "${DAOS_LIBRARIES}"
-        "${DAOS_TESTS_LIBRARIES}"
-)
-
-if(HAVE_FDB_BUILD_TOOLS)
-
-  list( APPEND fdb5_scripts fdb fdb-which )
-
-  foreach( _script ${fdb5_scripts} )
-    configure_file(scripts/${_script}.in ${CMAKE_BINARY_DIR}/bin/${_script} @ONLY)

=== tests/regressions/CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,7 @@
         add_subdirectory(FDB-282)
         add_subdirectory(FDB-291)
         add_subdirectory(FDB-292)
+        add_subdirectory(FDB-303)
         add_subdirectory(FDB-307)
         add_subdirectory(FDB-310)
     endif()

=== debian/changelog ===
fdb (5.14.0~rc1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 15 Sep 2024 10:45:35 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: fdb
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (=13),
  architecture-is-64-bit,
  ecbuild (>= 3.3.0-3),
@@ -15,10 +15,10 @@
  libpmem-dev [amd64 arm64 ppc64el riscv64],
  librados-dev [!sparc64 !ppc64 !alpha !loong64],
  libeccodes-tools
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/ecmwf/fdb
-Vcs-Browser: https://salsa.debian.org:/science-team/fdb.git
-Vcs-Git: https://salsa.debian.org:/science-team/fdb.git -b debian/latest
+Vcs-Browser: https://salsa.debian.org/science-team/fdb.git
+Vcs-Git: https://salsa.debian.org/science-team/fdb.git -b debian/latest
 
 Package: libfdb5-0d
 Section: libs
